Index: branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/AssemblyLoader.cs
===================================================================
--- branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/AssemblyLoader.cs	(revision 15852)
+++ branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/AssemblyLoader.cs	(revision 16307)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/AvalonEditWrapper.xaml.cs
===================================================================
--- branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/AvalonEditWrapper.xaml.cs	(revision 15852)
+++ branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/AvalonEditWrapper.xaml.cs	(revision 16307)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/CodeEditor.cs
===================================================================
--- branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/CodeEditor.cs	(revision 15852)
+++ branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/CodeEditor.cs	(revision 16307)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/CodeEditorBase.cs
===================================================================
--- branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/CodeEditorBase.cs	(revision 15852)
+++ branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/CodeEditorBase.cs	(revision 16307)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/CodeViewer.cs
===================================================================
--- branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/CodeViewer.cs	(revision 15852)
+++ branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/CodeViewer.cs	(revision 16307)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/GoToLineDialog.cs
===================================================================
--- branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/GoToLineDialog.cs	(revision 15852)
+++ branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/GoToLineDialog.cs	(revision 16307)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/ITextMarker.cs
===================================================================
--- branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/ITextMarker.cs	(revision 15852)
+++ branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/ITextMarker.cs	(revision 16307)
@@ -19,5 +19,5 @@
 
 /* HeuristicLab
- * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/LanguageFeatures/CSharpLanguageFeatures.cs
===================================================================
--- branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/LanguageFeatures/CSharpLanguageFeatures.cs	(revision 15852)
+++ branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/LanguageFeatures/CSharpLanguageFeatures.cs	(revision 16307)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/LanguageFeatures/CodeCompletion/CSharp/CSharpCodeCompletionContext.cs
===================================================================
--- branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/LanguageFeatures/CodeCompletion/CSharp/CSharpCodeCompletionContext.cs	(revision 15852)
+++ branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/LanguageFeatures/CodeCompletion/CSharp/CSharpCodeCompletionContext.cs	(revision 16307)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/LanguageFeatures/CodeCompletion/CSharp/CSharpCodeCompletionDataFactory.cs
===================================================================
--- branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/LanguageFeatures/CodeCompletion/CSharp/CSharpCodeCompletionDataFactory.cs	(revision 15852)
+++ branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/LanguageFeatures/CodeCompletion/CSharp/CSharpCodeCompletionDataFactory.cs	(revision 16307)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/LanguageFeatures/CodeCompletion/CSharp/CSharpCodeCompletionStrategy.cs
===================================================================
--- branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/LanguageFeatures/CodeCompletion/CSharp/CSharpCodeCompletionStrategy.cs	(revision 15852)
+++ branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/LanguageFeatures/CodeCompletion/CSharp/CSharpCodeCompletionStrategy.cs	(revision 16307)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/LanguageFeatures/CodeCompletion/CSharp/CSharpDocumentationBuilder.cs
===================================================================
--- branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/LanguageFeatures/CodeCompletion/CSharp/CSharpDocumentationBuilder.cs	(revision 15852)
+++ branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/LanguageFeatures/CodeCompletion/CSharp/CSharpDocumentationBuilder.cs	(revision 16307)
@@ -19,5 +19,5 @@
 
 /* HeuristicLab
- * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/LanguageFeatures/CodeCompletion/CSharp/CSharpInsightItem.cs
===================================================================
--- branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/LanguageFeatures/CodeCompletion/CSharp/CSharpInsightItem.cs	(revision 15852)
+++ branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/LanguageFeatures/CodeCompletion/CSharp/CSharpInsightItem.cs	(revision 16307)
@@ -19,5 +19,5 @@
 
 /* HeuristicLab
- * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/LanguageFeatures/CodeCompletion/CSharp/CSharpOverloadProvider.cs
===================================================================
--- branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/LanguageFeatures/CodeCompletion/CSharp/CSharpOverloadProvider.cs	(revision 15852)
+++ branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/LanguageFeatures/CodeCompletion/CSharp/CSharpOverloadProvider.cs	(revision 16307)
@@ -21,5 +21,5 @@
 
 /* HeuristicLab
- * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/LanguageFeatures/CodeCompletion/CSharp/CompletionData/CodeCompletionData.cs
===================================================================
--- branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/LanguageFeatures/CodeCompletion/CSharp/CompletionData/CodeCompletionData.cs	(revision 15852)
+++ branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/LanguageFeatures/CodeCompletion/CSharp/CompletionData/CodeCompletionData.cs	(revision 16307)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/LanguageFeatures/CodeCompletion/CSharp/CompletionData/EntityCompletionData.cs
===================================================================
--- branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/LanguageFeatures/CodeCompletion/CSharp/CompletionData/EntityCompletionData.cs	(revision 15852)
+++ branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/LanguageFeatures/CodeCompletion/CSharp/CompletionData/EntityCompletionData.cs	(revision 16307)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/LanguageFeatures/CodeCompletion/CSharp/CompletionData/Images/CompletionImage.cs
===================================================================
--- branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/LanguageFeatures/CodeCompletion/CSharp/CompletionData/Images/CompletionImage.cs	(revision 15852)
+++ branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/LanguageFeatures/CodeCompletion/CSharp/CompletionData/Images/CompletionImage.cs	(revision 16307)
@@ -4,5 +4,5 @@
 
 /* HeuristicLab
- * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/LanguageFeatures/CodeCompletion/CSharp/CompletionData/VariableCompletionData.cs
===================================================================
--- branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/LanguageFeatures/CodeCompletion/CSharp/CompletionData/VariableCompletionData.cs	(revision 15852)
+++ branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/LanguageFeatures/CodeCompletion/CSharp/CompletionData/VariableCompletionData.cs	(revision 16307)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/LanguageFeatures/CodeCompletion/CodeCompletionResult.cs
===================================================================
--- branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/LanguageFeatures/CodeCompletion/CodeCompletionResult.cs	(revision 15852)
+++ branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/LanguageFeatures/CodeCompletion/CodeCompletionResult.cs	(revision 16307)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/LanguageFeatures/CodeCompletion/CodeCompletionStrategy.cs
===================================================================
--- branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/LanguageFeatures/CodeCompletion/CodeCompletionStrategy.cs	(revision 15852)
+++ branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/LanguageFeatures/CodeCompletion/CodeCompletionStrategy.cs	(revision 16307)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/LanguageFeatures/CodeFolding/CSharp/CSharpCodeFoldingContext.cs
===================================================================
--- branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/LanguageFeatures/CodeFolding/CSharp/CSharpCodeFoldingContext.cs	(revision 15852)
+++ branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/LanguageFeatures/CodeFolding/CSharp/CSharpCodeFoldingContext.cs	(revision 16307)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/LanguageFeatures/CodeFolding/CSharp/CSharpCodeFoldingStrategy.cs
===================================================================
--- branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/LanguageFeatures/CodeFolding/CSharp/CSharpCodeFoldingStrategy.cs	(revision 15852)
+++ branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/LanguageFeatures/CodeFolding/CSharp/CSharpCodeFoldingStrategy.cs	(revision 16307)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/LanguageFeatures/CodeFolding/CodeFoldingResult.cs
===================================================================
--- branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/LanguageFeatures/CodeFolding/CodeFoldingResult.cs	(revision 15852)
+++ branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/LanguageFeatures/CodeFolding/CodeFoldingResult.cs	(revision 16307)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/LanguageFeatures/CodeFolding/CodeFoldingStrategy.cs
===================================================================
--- branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/LanguageFeatures/CodeFolding/CodeFoldingStrategy.cs	(revision 15852)
+++ branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/LanguageFeatures/CodeFolding/CodeFoldingStrategy.cs	(revision 16307)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/LanguageFeatures/CodeFolding/XML/XmlCodeFoldingStrategy.cs
===================================================================
--- branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/LanguageFeatures/CodeFolding/XML/XmlCodeFoldingStrategy.cs	(revision 15852)
+++ branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/LanguageFeatures/CodeFolding/XML/XmlCodeFoldingStrategy.cs	(revision 16307)
@@ -19,5 +19,5 @@
 
 /* HeuristicLab
- * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/LanguageFeatures/Helpers/CSharpParsingHelpers.cs
===================================================================
--- branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/LanguageFeatures/Helpers/CSharpParsingHelpers.cs	(revision 15852)
+++ branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/LanguageFeatures/Helpers/CSharpParsingHelpers.cs	(revision 16307)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/LanguageFeatures/Interfaces/ICodeCompletionStrategy.cs
===================================================================
--- branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/LanguageFeatures/Interfaces/ICodeCompletionStrategy.cs	(revision 15852)
+++ branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/LanguageFeatures/Interfaces/ICodeCompletionStrategy.cs	(revision 16307)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/LanguageFeatures/Interfaces/ICodeFoldingStrategy.cs
===================================================================
--- branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/LanguageFeatures/Interfaces/ICodeFoldingStrategy.cs	(revision 15852)
+++ branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/LanguageFeatures/Interfaces/ICodeFoldingStrategy.cs	(revision 16307)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/LanguageFeatures/Interfaces/ILanguageFeatures.cs
===================================================================
--- branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/LanguageFeatures/Interfaces/ILanguageFeatures.cs	(revision 15852)
+++ branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/LanguageFeatures/Interfaces/ILanguageFeatures.cs	(revision 16307)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/LanguageFeatures/Interfaces/IUpdatableOverloadProvider.cs
===================================================================
--- branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/LanguageFeatures/Interfaces/IUpdatableOverloadProvider.cs	(revision 15852)
+++ branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/LanguageFeatures/Interfaces/IUpdatableOverloadProvider.cs	(revision 16307)
@@ -1,5 +1,5 @@
 #region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/LanguageFeatures/LanguageFeatures.cs
===================================================================
--- branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/LanguageFeatures/LanguageFeatures.cs	(revision 15852)
+++ branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/LanguageFeatures/LanguageFeatures.cs	(revision 16307)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/LanguageFeatures/XmlLanguageFeatures.cs
===================================================================
--- branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/LanguageFeatures/XmlLanguageFeatures.cs	(revision 15852)
+++ branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/LanguageFeatures/XmlLanguageFeatures.cs	(revision 16307)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/MethodDefinitionReadOnlySectionProvider.cs
===================================================================
--- branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/MethodDefinitionReadOnlySectionProvider.cs	(revision 15852)
+++ branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/MethodDefinitionReadOnlySectionProvider.cs	(revision 16307)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/Plugin.cs.frame
===================================================================
--- branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/Plugin.cs.frame	(revision 15852)
+++ branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/Plugin.cs.frame	(revision 16307)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -23,5 +23,5 @@
 
 namespace HeuristicLab.CodeEditor {
-  [Plugin("HeuristicLab.CodeEditor", "3.4.3.$WCREV$")]
+  [Plugin("HeuristicLab.CodeEditor", "3.4.4.$WCREV$")]
   [PluginFile("HeuristicLab.CodeEditor-3.4.dll", PluginFileType.Assembly)]
   [PluginDependency("HeuristicLab.Common", "3.3")]
Index: branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/Properties/AssemblyInfo.cs.frame
===================================================================
--- branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/Properties/AssemblyInfo.cs.frame	(revision 15852)
+++ branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/Properties/AssemblyInfo.cs.frame	(revision 16307)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -31,5 +31,5 @@
 [assembly: AssemblyCompany("")]
 [assembly: AssemblyProduct("HeuristicLab")]
-[assembly: AssemblyCopyright("(c) 2002-2016 HEAL & ic#code")]
+[assembly: AssemblyCopyright("(c) 2002-2018 HEAL & ic#code")]
 [assembly: AssemblyTrademark("")]
 [assembly: AssemblyCulture("")]
@@ -54,3 +54,3 @@
 // [assembly: AssemblyVersion("1.0.*")]
 [assembly: AssemblyVersion("3.4.0.0")]
-[assembly: AssemblyFileVersion("3.4.3.$WCREV$")]
+[assembly: AssemblyFileVersion("3.4.4.$WCREV$")]
Index: branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/SimpleCodeEditor.cs
===================================================================
--- branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/SimpleCodeEditor.cs	(revision 15852)
+++ branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/SimpleCodeEditor.cs	(revision 16307)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/TextMarkerService.cs
===================================================================
--- branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/TextMarkerService.cs	(revision 15852)
+++ branches/2845_EnhancedProgress/HeuristicLab.CodeEditor/3.4/TextMarkerService.cs	(revision 16307)
@@ -19,5 +19,5 @@
 
 /* HeuristicLab
- * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.